Loading...
Searching...
No Matches
LeafData< Fp8, CoordT, MaskT, LOG2DIM > Struct Template Reference

`#include <nanovdb/NanoVDB.h>`

Inheritance diagram for LeafData< Fp8, CoordT, MaskT, LOG2DIM >:

## Public Types

using | BaseT = LeafFnBase<CoordT, MaskT, LOG2DIM>
using | BuildType = Fp8
using | ArrayType = uint8_t
using | ValueType
using | FloatType

## Public Member Functions

float | getValue (uint32_t i) const
| LeafData ()=delete
| This class cannot be constructed or deleted.
| LeafData (const LeafData &)=delete
LeafData & | operator= (const LeafData &)=delete
| ~LeafData ()=delete
void | setValueOnly (uint32_t offset, const ValueType &value)
void | setValue (uint32_t offset, const ValueType &value)
ValueType | getMin () const
ValueType | getMax () const
FloatType | getAvg () const
FloatType | getDev () const
void | setMin (const ValueType &v)
void | setMax (const ValueType &v)
void | setAvg (const FloatType &v)
void | setDev (const FloatType &v)
void | setOrigin (const T &ijk)
void | init (float min, float max, uint8_t bitWidth)
void | setMin (float min)
void | setMax (float max)
void | setAvg (float avg)
void | setDev (float dev)

## Static Public Member Functions

static constexpr int64_t | memUsage ()
static constexpr uint32_t | padding ()
static constexpr uint8_t | bitWidth ()

## Public Attributes

uint8_t | mCode [1u<< 3 *LOG2DIM]
CoordT | mBBoxMin
uint8_t | mBBoxDif [3]
uint8_t | mFlags
MaskT< LOG2DIM > | mValueMask
ValueType | mMinimum
ValueType | mMaximum
FloatType | mAverage
FloatType | mStdDevi
ValueType | mValues [1u<< 3 *LOG2DIM]
float | mQuantum
uint16_t | mMin
uint16_t | mMax
uint16_t | mAvg
uint16_t | mDev

## Static Public Attributes

static constexpr bool | FIXED_SIZE = true

## Member Typedef Documentation

## ArrayType

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using ArrayType = uint8_t

## BaseT

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BaseT = LeafFnBase<CoordT, MaskT, LOG2DIM>

## BuildType

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BuildType = Fp8

## FloatType

using FloatType

## ValueType

using ValueType

## Constructor & Destructor Documentation

## LeafData() [1/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( |  | ) |

delete

This class cannot be constructed or deleted.

## LeafData() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( | const LeafData< Fp8, CoordT, MaskT, LOG2DIM > & |  | ) |

delete

## ~LeafData()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

~LeafData | ( |  | ) |

delete

## Member Function Documentation

## bitWidth()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

constexpr uint8_t bitWidth | ( |  | ) |

inline static constexpr

## getAvg()

FloatType getAvg | ( |  | ) | const

inline

## getDev()

FloatType getDev | ( |  | ) | const

inline

## getMax()

ValueType getMax | ( |  | ) | const

inline

## getMin()

ValueType getMin | ( |  | ) | const

inline

## getValue()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

float getValue | ( | uint32_t | i | ) | const

inline

## init()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void init | ( | float | min,
|  | float | max,
|  | uint8_t | bitWidth )

inline inherited

## memUsage()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

constexpr int64_t memUsage | ( |  | ) |

inline static constexpr

## operator=()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData & operator= | ( | const LeafData< Fp8, CoordT, MaskT, LOG2DIM > & |  | ) |

delete

## padding()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

constexpr uint32_t padding | ( |  | ) |

inline static constexpr

## setAvg() [1/2]

void setAvg | ( | const FloatType & | v | ) |

inline

## setAvg() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setAvg | ( | float | avg | ) |

inline inherited

Note
  min <= avg <= max or 0 <= (avg-min)/(min-max) <= 1

## setDev() [1/2]

void setDev | ( | const FloatType & | v | ) |

inline

## setDev() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setDev | ( | float | dev | ) |

inline inherited

Note
  0 <= StdDev <= max-min or 0 <= StdDev/(max-min) <= 1

## setMax() [1/2]

void setMax | ( | const ValueType & | v | ) |

inline

## setMax() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMax | ( | float | max | ) |

inline inherited

Note
  min <= X <= max or 0 <= (X-min)/(min-max) <= 1

## setMin() [1/2]

void setMin | ( | const ValueType & | v | ) |

inline

## setMin() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMin | ( | float | min | ) |

inline inherited

Note
  min <= X <= max or 0 <= (X-min)/(min-max) <= 1

## setOrigin()

void setOrigin | ( | const T & | ijk | ) |

inline

## setValue()

void setValue | ( | uint32_t | offset,
|  | const ValueType & | value )

inline

## setValueOnly()

void setValueOnly | ( | uint32_t | offset,
|  | const ValueType & | value )

inline

## Member Data Documentation

## FIXED_SIZE

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

bool FIXED_SIZE = true

static constexpr

## mAverage

FloatType mAverage

## mAvg

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mAvg

inherited

## mBBoxDif

uint8_t mBBoxDif[3]

## mBBoxMin

CoordT mBBoxMin

## mCode

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint8_t mCode[1u<< 3 *LOG2DIM]

## mDev

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mDev

inherited

## mFlags

uint8_t mFlags

## mMax

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mMax

inherited

## mMaximum

ValueType mMaximum

## mMin

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mMin

inherited

## mMinimum

ValueType mMinimum

## mQuantum

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

float mQuantum

inherited

## mStdDevi

FloatType mStdDevi

## mValueMask

MaskT<LOG2DIM> mValueMask

## mValues

ValueType mValues[1u<< 3 *LOG2DIM]